]> git.ipfire.org Git - thirdparty/git.git/blame - t/test-lib.sh
cmake: avoid editing t/test-lib.sh
[thirdparty/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
85176d72
FC
22 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
9dbf20e7
ÆAB
24 TEST_DIRECTORY=$(pwd)
25else
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
30 # same path.
31 #
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
35 # needing to exist.
85176d72 36 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
37fi
38if test -z "$TEST_OUTPUT_DIRECTORY"
39then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
43fi
b9638d72
ÆAB
44GIT_BUILD_DIR="${TEST_DIRECTORY%/t}"
45if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
9dbf20e7
ÆAB
46then
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
48 exit 1
49fi
ee9e66e4
JS
50if test -f "$GIT_BUILD_DIR/GIT-BUILD-DIR"
51then
52 GIT_BUILD_DIR="$(cat "$GIT_BUILD_DIR/GIT-BUILD-DIR")" || exit 1
53 # On Windows, we must convert Windows paths lest they contain a colon
54 case "$(uname -s)" in
55 *MINGW*)
56 GIT_BUILD_DIR="$(cygpath -au "$GIT_BUILD_DIR")"
57 ;;
58 esac
59fi
3c8f12c9 60
66c1a568
ÆAB
61# Prepend a string to a VAR using an arbitrary ":" delimiter, not
62# adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
63#
64# VAR=$1${VAR:+${1:+$2}$VAR}
65#
66# Usage (using ":" as the $2 delimiter):
67#
68# prepend_var VAR : VALUE
69prepend_var () {
361fa321 70 eval "$1=\"$3\${$1:+${3:+$2}\$$1}\""
66c1a568
ÆAB
71}
72
73# If [AL]SAN is in effect we want to abort so that we notice
74# problems. The GIT_SAN_OPTIONS variable can be used to set common
75# defaults shared between [AL]SAN_OPTIONS.
76prepend_var GIT_SAN_OPTIONS : abort_on_error=1
361fa321 77prepend_var GIT_SAN_OPTIONS : strip_path_prefix="$GIT_BUILD_DIR/"
66c1a568 78
d0cc5796
JK
79# If we were built with ASAN, it may complain about leaks
80# of program-lifetime variables. Disable it by default to lower
81# the noise level. This needs to happen at the start of the script,
82# before we even do our "did we build git yet" check (since we don't
83# want that one to complain to stderr).
66c1a568
ÆAB
84prepend_var ASAN_OPTIONS : $GIT_SAN_OPTIONS
85prepend_var ASAN_OPTIONS : detect_leaks=0
d0cc5796
JK
86export ASAN_OPTIONS
87
66c1a568 88prepend_var LSAN_OPTIONS : $GIT_SAN_OPTIONS
71f26798 89prepend_var LSAN_OPTIONS : fast_unwind_on_malloc=0
85b81b35
JK
90export LSAN_OPTIONS
91
8abfdf44
JS
92if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
93then
94 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
95 exit 1
96fi
97. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
98export PERL_PATH SHELL_PATH
99
ade15525
PS
100# In t0000, we need to override test directories of nested testcases. In case
101# the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
102# reset this value to instead contain what the developer has specified. We thus
103# have this knob to allow overriding the directory.
104if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
105then
106 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
107fi
108
b02e7d5d
JS
109# Disallow the use of abbreviated options in the test suite by default
110if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
111then
112 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
113 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
114fi
115
97c8aac9
ÆAB
116# Explicitly set the default branch name for testing, to avoid the
117# transitory "git init" warning under --verbose.
118: ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
119export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
120
2006f0ad
RR
121################################################################
122# It appears that people try to run tests without building...
8abfdf44 123"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
2006f0ad
RR
124if test $? != 1
125then
ed306e4e
JS
126 if test -n "$GIT_TEST_INSTALLED"
127 then
128 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
129 else
130 echo >&2 'error: you do not seem to have built git yet.'
131 fi
2006f0ad
RR
132 exit 1
133fi
134
8cf58006 135store_arg_to=
78dc0887
MT
136opt_required_arg=
137# $1: option string
138# $2: name of the var where the arg will be stored
139mark_option_requires_arg () {
140 if test -n "$opt_required_arg"
8cf58006 141 then
78dc0887
MT
142 echo "error: options that require args cannot be bundled" \
143 "together: '$opt_required_arg' and '$1'" >&2
144 exit 1
8cf58006 145 fi
78dc0887
MT
146 opt_required_arg=$1
147 store_arg_to=$2
148}
149
78d5e4cf
JS
150# These functions can be overridden e.g. to output JUnit XML
151start_test_output () { :; }
152start_test_case_output () { :; }
153finalize_test_case_output () { :; }
154finalize_test_output () { :; }
155
78dc0887
MT
156parse_option () {
157 local opt="$1"
8cf58006
SG
158
159 case "$opt" in
160 -d|--d|--de|--deb|--debu|--debug)
161 debug=t ;;
162 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
163 immediate=t ;;
164 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
165 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
166 -r)
78dc0887 167 mark_option_requires_arg "$opt" run_list
8cf58006
SG
168 ;;
169 --run=*)
170 run_list=${opt#--*=} ;;
171 -h|--h|--he|--hel|--help)
172 help=t ;;
173 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
174 verbose=t ;;
175 --verbose-only=*)
176 verbose_only=${opt#--*=}
177 ;;
178 -q|--q|--qu|--qui|--quie|--quiet)
179 # Ignore --quiet under a TAP::Harness. Saying how many tests
180 # passed without the ok/not ok details is always an error.
181 test -z "$HARNESS_ACTIVE" && quiet=t ;;
182 --with-dashes)
183 with_dashes=t ;;
dd167a30
JS
184 --no-bin-wrappers)
185 no_bin_wrappers=t ;;
8cf58006
SG
186 --no-color)
187 color= ;;
188 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
189 valgrind=memcheck
190 tee=t
191 ;;
192 --valgrind=*)
193 valgrind=${opt#--*=}
194 tee=t
195 ;;
196 --valgrind-only=*)
197 valgrind_only=${opt#--*=}
198 tee=t
199 ;;
200 --tee)
201 tee=t ;;
202 --root=*)
203 root=${opt#--*=} ;;
204 --chain-lint)
205 GIT_TEST_CHAIN_LINT=1 ;;
206 --no-chain-lint)
207 GIT_TEST_CHAIN_LINT=0 ;;
208 -x)
209 trace=t ;;
210 -V|--verbose-log)
211 verbose_log=t
212 tee=t
213 ;;
22231908 214 --write-junit-xml)
78d5e4cf 215 . "$TEST_DIRECTORY/test-lib-junit.sh"
22231908 216 ;;
0f5ae593
JS
217 --github-workflow-markup)
218 . "$TEST_DIRECTORY/test-lib-github-workflow-markup.sh"
22231908 219 ;;
fb7d1e3a
SG
220 --stress)
221 stress=t ;;
222 --stress=*)
f5457371
JS
223 echo "error: --stress does not accept an argument: '$opt'" >&2
224 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
225 exit 1
226 ;;
227 --stress-jobs=*)
228 stress=t;
134768cf
SG
229 stress_jobs=${opt#--*=}
230 case "$stress_jobs" in
7d661e5e 231 *[!0-9]*|0*|"")
f5457371 232 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
fb7d1e3a
SG
233 exit 1
234 ;;
235 *) # Good.
236 ;;
237 esac
238 ;;
76e27fbf 239 --stress-limit=*)
de69e6f6 240 stress=t;
76e27fbf
SG
241 stress_limit=${opt#--*=}
242 case "$stress_limit" in
7d661e5e 243 *[!0-9]*|0*|"")
76e27fbf
SG
244 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
245 exit 1
246 ;;
247 *) # Good.
248 ;;
249 esac
250 ;;
8cf58006
SG
251 *)
252 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
253 esac
78dc0887
MT
254}
255
256# Parse options while taking care to leave $@ intact, so we will still
257# have all the original command line options when executing the test
258# script again for '--tee' and '--verbose-log' later.
259for opt
260do
261 if test -n "$store_arg_to"
262 then
263 eval $store_arg_to=\$opt
264 store_arg_to=
265 opt_required_arg=
266 continue
267 fi
8cf58006 268
78dc0887
MT
269 case "$opt" in
270 --*|-?)
271 parse_option "$opt" ;;
272 -?*)
273 # bundled short options must be fed separately to parse_option
274 opt=${opt#-}
275 while test -n "$opt"
276 do
277 extra=${opt#?}
278 this=${opt%$extra}
279 opt=$extra
280 parse_option "-$this"
281 done
282 ;;
283 *)
284 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
285 esac
8cf58006
SG
286done
287if test -n "$store_arg_to"
288then
78dc0887 289 echo "error: $opt_required_arg requires an argument" >&2
8cf58006
SG
290 exit 1
291fi
292
293if test -n "$valgrind_only"
294then
295 test -z "$valgrind" && valgrind=memcheck
296 test -z "$verbose" && verbose_only="$valgrind_only"
297elif test -n "$valgrind"
298then
299 test -z "$verbose_log" && verbose=t
300fi
301
fb7d1e3a
SG
302if test -n "$stress"
303then
304 verbose=t
305 trace=t
306 immediate=t
307fi
308
309TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
62c379b8 310TEST_NAME="$(basename "$0" .sh)"
ffe1afe6
SG
311TEST_NUMBER="${TEST_NAME%%-*}"
312TEST_NUMBER="${TEST_NUMBER#t}"
62c379b8 313TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
fb7d1e3a
SG
314TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
315TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
61f292db
SG
316test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
317case "$TRASH_DIRECTORY" in
318/*) ;; # absolute path is good
319 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
320esac
62c379b8 321
fb7d1e3a
SG
322# If --stress was passed, run this test repeatedly in several parallel loops.
323if test "$GIT_TEST_STRESS_STARTED" = "done"
324then
325 : # Don't stress test again.
326elif test -n "$stress"
327then
134768cf 328 if test -n "$stress_jobs"
fb7d1e3a 329 then
134768cf 330 job_count=$stress_jobs
fb7d1e3a
SG
331 elif test -n "$GIT_TEST_STRESS_LOAD"
332 then
333 job_count="$GIT_TEST_STRESS_LOAD"
334 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
335 test -n "$job_count"
336 then
337 job_count=$((2 * $job_count))
338 else
339 job_count=8
340 fi
341
342 mkdir -p "$TEST_RESULTS_DIR"
343 stressfail="$TEST_RESULTS_BASE.stress-failed"
344 rm -f "$stressfail"
345
346 stress_exit=0
347 trap '
348 kill $job_pids 2>/dev/null
349 wait
350 stress_exit=1
351 ' TERM INT HUP
352
353 job_pids=
354 job_nr=0
355 while test $job_nr -lt "$job_count"
356 do
357 (
358 GIT_TEST_STRESS_STARTED=done
359 GIT_TEST_STRESS_JOB_NR=$job_nr
360 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
361
362 trap '
363 kill $test_pid 2>/dev/null
364 wait
365 exit 1
366 ' TERM INT
367
76e27fbf
SG
368 cnt=1
369 while ! test -e "$stressfail" &&
370 { test -z "$stress_limit" ||
371 test $cnt -le $stress_limit ; }
fb7d1e3a
SG
372 do
373 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
374 test_pid=$!
375
376 if wait $test_pid
377 then
378 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
379 else
380 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
381 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
382 fi
383 cnt=$(($cnt + 1))
384 done
385 ) &
386 job_pids="$job_pids $!"
387 job_nr=$(($job_nr + 1))
388 done
389
390 wait
391
392 if test -f "$stressfail"
393 then
76e27fbf 394 stress_exit=1
fb7d1e3a
SG
395 echo "Log(s) of failed test run(s):"
396 for failed_job_nr in $(sort -n "$stressfail")
397 do
398 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
399 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
400 done
401 rm -rf "$TRASH_DIRECTORY.stress-failed"
402 # Move the last one.
403 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
404 fi
405
406 exit $stress_exit
407fi
408
4cde519f
RR
409# if --tee was passed, write the output not only to the terminal, but
410# additionally to the file test-results/$BASENAME.out, too.
8cf58006
SG
411if test "$GIT_TEST_TEE_STARTED" = "done"
412then
413 : # do not redirect again
414elif test -n "$tee"
415then
62c379b8 416 mkdir -p "$TEST_RESULTS_DIR"
452320f1
JK
417
418 # Make this filename available to the sub-process in case it is using
419 # --verbose-log.
62c379b8 420 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
452320f1
JK
421 export GIT_TEST_TEE_OUTPUT_FILE
422
423 # Truncate before calling "tee -a" to get rid of the results
424 # from any previous runs.
425 >"$GIT_TEST_TEE_OUTPUT_FILE"
426
3f824e91 427 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
62c379b8
SG
428 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
429 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
4cde519f 430 exit
8cf58006
SG
431fi
432
433if test -n "$trace" && test -n "$test_untraceable"
434then
435 # '-x' tracing requested, but this test script can't be reliably
436 # traced, unless it is run with a Bash version supporting
437 # BASH_XTRACEFD (introduced in Bash v4.1).
438 #
439 # Perform this version check _after_ the test script was
440 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
441 # '--verbose-log', so the right shell is checked and the
442 # warning is issued only once.
443 if test -n "$BASH_VERSION" && eval '
444 test ${BASH_VERSINFO[0]} -gt 4 || {
445 test ${BASH_VERSINFO[0]} -eq 4 &&
446 test ${BASH_VERSINFO[1]} -ge 1
447 }
448 '
449 then
450 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
451 else
452 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
453 trace=
454 fi
455fi
456if test -n "$trace" && test -z "$verbose_log"
457then
458 verbose=t
459fi
4cde519f 460
390b44eb
FC
461# Since bash 5.0, checkwinsize is enabled by default which does
462# update the COLUMNS variable every time a non-builtin command
463# completes, even for non-interactive shells.
464# Disable that since we are aiming for repeatability.
465test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
466
e1970ce4 467# For repeatability, reset the environment to known value.
d5c1b7c2 468# TERM is sanitized below, after saving color control sequences.
e1970ce4 469LANG=C
899460f3 470LC_ALL=C
d9bdd39e 471PAGER=cat
e1970ce4 472TZ=UTC
c49a177b
ÆAB
473COLUMNS=80
474export LANG LC_ALL PAGER TZ COLUMNS
8ff99e74 475EDITOR=:
6cdccfce 476
661bfd13
SL
477# A call to "unset" with no arguments causes at least Solaris 10
478# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
479# deriving from the command substitution clustered with the other
480# ones.
c49a177b 481unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
95a1d12e 482 my @env = keys %ENV;
730477f1
JL
483 my $ok = join("|", qw(
484 TRACE
485 DEBUG
730477f1
JL
486 TEST
487 .*_TEST
488 PROVE
489 VALGRIND
ac001282 490 UNZIP
edb54081 491 PERF_
e2a0ccc0 492 CURL_VERBOSE
4527aa10 493 TRACE_CURL
730477f1
JL
494 ));
495 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
496 print join("\n", @vars);
497')
7976e901 498unset XDG_CACHE_HOME
5adf84eb 499unset XDG_CONFIG_HOME
8bade1e1 500unset GITPERLLIB
944d808e
JS
501unset GIT_TRACE2_PARENT_NAME
502unset GIT_TRACE2_PARENT_SID
d8b8217c
PB
503TEST_AUTHOR_LOCALNAME=author
504TEST_AUTHOR_DOMAIN=example.com
505GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
29e55cd5 506GIT_AUTHOR_NAME='A U Thor'
f2e3937d 507GIT_AUTHOR_DATE='1112354055 +0200'
d8b8217c
PB
508TEST_COMMITTER_LOCALNAME=committer
509TEST_COMMITTER_DOMAIN=example.com
510GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
29e55cd5 511GIT_COMMITTER_NAME='C O Mitter'
f2e3937d 512GIT_COMMITTER_DATE='1112354055 +0200'
8d0fc48f 513GIT_MERGE_VERBOSITY=5
f8246281
JH
514GIT_MERGE_AUTOEDIT=no
515export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
516export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
517export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
f2e3937d 518export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
d33738d7 519export EDITOR
e1970ce4 520
02a32dbf 521GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
522export GIT_DEFAULT_HASH
f3b964a0
EN
523GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
524export GIT_TEST_MERGE_ALGORITHM
02a32dbf 525
124647c4
KB
526# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
527GIT_TRACE_BARE=1
528export GIT_TRACE_BARE
529
b8de3d6e
DS
530# Some tests scan the GIT_TRACE2_EVENT feed for events, but the
531# default depth is 2, which frequently causes issues when the
532# events are wrapped in new regions. Set it to a sufficiently
533# large depth to avoid custom changes in the test suite.
534GIT_TRACE2_EVENT_NESTING=100
535export GIT_TRACE2_EVENT_NESTING
536
1f357b04
BP
537# Use specific version of the index file format
538if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
5d9fc888 539then
1f357b04 540 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
5d9fc888
TG
541 export GIT_INDEX_VERSION
542fi
543
5338ed2b
JK
544if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
545then
546 GIT_PERL_FATAL_WARNINGS=1
547 export GIT_PERL_FATAL_WARNINGS
548fi
549
412e4cae
EW
550case $GIT_TEST_FSYNC in
551'')
552 GIT_TEST_FSYNC=0
553 export GIT_TEST_FSYNC
554 ;;
555esac
556
067109a5
PW
557# Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
558# the test with valgrind and have not compiled with SANITIZE=address.
8cf58006 559if test -n "$valgrind" ||
067109a5 560 test -n "$SANITIZE_ADDRESS" ||
ee1431bf 561 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
562then
563 setup_malloc_check () {
564 : nothing
565 }
566 teardown_malloc_check () {
567 : nothing
568 }
569else
570 setup_malloc_check () {
baedc595
MG
571 local g
572 local t
1b3185fc
JH
573 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
574 export MALLOC_CHECK_ MALLOC_PERTURB_
131b94a1
EP
575 if _GLIBC_VERSION=$(getconf GNU_LIBC_VERSION 2>/dev/null) &&
576 _GLIBC_VERSION=${_GLIBC_VERSION#"glibc "} &&
577 expr 2.34 \<= "$_GLIBC_VERSION" >/dev/null
578 then
579 g=
580 LD_PRELOAD="libc_malloc_debug.so.0"
581 for t in \
582 glibc.malloc.check=1 \
583 glibc.malloc.perturb=165
584 do
585 g="${g#:}:$t"
586 done
587 GLIBC_TUNABLES=$g
588 export LD_PRELOAD GLIBC_TUNABLES
589 fi
1b3185fc
JH
590 }
591 teardown_malloc_check () {
592 unset MALLOC_CHECK_ MALLOC_PERTURB_
131b94a1 593 unset LD_PRELOAD GLIBC_TUNABLES
1b3185fc
JH
594 }
595fi
a731fa91 596
886a3907
JH
597# Protect ourselves from common misconfiguration to export
598# CDPATH into the environment
599unset CDPATH
600
5565f47c 601unset GREP_OPTIONS
ac001282 602unset UNZIP
5565f47c 603
3d5c0cc9 604case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 6051|2|true)
025232e8 606 GIT_TRACE=4
1c0cc756 607 ;;
6ce4e61f
CC
608esac
609
3f4ab627
JH
610# Line feed
611LF='
612'
613
bd482d6e
DL
614# Single quote
615SQ=\'
616
a42643aa
JK
617# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
618# when case-folding filenames
619u200c=$(printf '\342\200\214')
620
70507911 621export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
342e9ef2 622
e1970ce4
JH
623# Each test should start with something like this, after copyright notices:
624#
625# test_description='Description of this test...
626# This test checks if command xyzzy does the right thing...
627# '
628# . ./test-lib.sh
d5c1b7c2 629test "x$TERM" != "xdumb" && (
ca92a660
RH
630 test -t 1 &&
631 tput bold >/dev/null 2>&1 &&
632 tput setaf 1 >/dev/null 2>&1 &&
633 tput sgr0 >/dev/null 2>&1
634 ) &&
635 color=t
e1970ce4 636
ca92a660
RH
637if test -n "$color"
638then
d5c1b7c2
RH
639 # Save the color control sequences now rather than run tput
640 # each time say_color() is called. This is done for two
641 # reasons:
642 # * TERM will be changed to dumb
643 # * HOME will be changed to a temporary directory and tput
644 # might need to read ~/.terminfo from the original HOME
645 # directory to get the control sequences
646 # Note: This approach assumes the control sequences don't end
647 # in a newline for any terminal of interest (command
648 # substitutions strip trailing newlines). Given that most
649 # (all?) terminals in common use are related to ECMA-48, this
650 # shouldn't be a problem.
651 say_color_error=$(tput bold; tput setaf 1) # bold red
652 say_color_skip=$(tput setaf 4) # blue
653 say_color_warn=$(tput setaf 3) # brown/yellow
654 say_color_pass=$(tput setaf 2) # green
655 say_color_info=$(tput setaf 6) # cyan
656 say_color_reset=$(tput sgr0)
657 say_color_="" # no formatting for normal text
ca92a660 658 say_color () {
d5c1b7c2
RH
659 test -z "$1" && test -n "$quiet" && return
660 eval "say_color_color=\$say_color_$1"
ca92a660 661 shift
d5c1b7c2 662 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
663 }
664else
665 say_color() {
666 test -z "$1" && test -n "$quiet" && return
667 shift
668 printf "%s\n" "$*"
669 }
670fi
671
add5240f 672USER_TERM="$TERM"
d5c1b7c2 673TERM=dumb
add5240f 674export TERM USER_TERM
d5c1b7c2 675
a6714088
FS
676# What is written by tests to stdout and stderr is sent to different places
677# depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
678# with --tee option, etc.). We save the original stdin to FD #6 and stdout and
679# stderr to #5 and #7, so that the test framework can use them (e.g. for
680# printing errors within the test framework) independently of the test mode.
681exec 5>&1
682exec 6<&0
683exec 7>&2
684
8583bf75 685_error_exit () {
78d5e4cf 686 finalize_test_output
6e7b5aaf 687 GIT_EXIT_OK=t
55db1df0
PH
688 exit 1
689}
690
8583bf75
ÆAB
691error () {
692 say_color error "error: $*"
693 _error_exit
694}
695
165293af
SG
696BUG () {
697 error >&7 "bug in the test script: $*"
698}
699
234383cd
ÆAB
700BAIL_OUT () {
701 test $# -ne 1 && BUG "1 param"
702
703 # Do not change "Bail out! " string. It's part of TAP syntax:
704 # https://testanything.org/tap-specification.html
705 local bail_out="Bail out! "
706 local message="$1"
707
a6714088 708 say_color >&5 error $bail_out "$message"
234383cd
ÆAB
709 _error_exit
710}
711
55db1df0
PH
712say () {
713 say_color info "$*"
714}
715
614fe015
JK
716if test -n "$HARNESS_ACTIVE"
717then
718 if test "$verbose" = t || test -n "$verbose_only"
719 then
234383cd 720 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
614fe015
JK
721 fi
722fi
723
570f3226
MB
724test "${test_description}" != "" ||
725error "Test script did not set test_description."
726
727if test "$help" = "t"
728then
cb1aefda 729 printf '%s\n' "$test_description"
570f3226
MB
730 exit 0
731fi
732
452320f1
JK
733if test "$verbose_log" = "t"
734then
735 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
736elif test "$verbose" = "t"
e1970ce4
JH
737then
738 exec 4>&2 3>&1
739else
740 exec 4>/dev/null 3>/dev/null
741fi
742
d88785e4
JK
743# Send any "-x" output directly to stderr to avoid polluting tests
744# which capture stderr. We can do this unconditionally since it
745# has no effect if tracing isn't turned on.
746#
747# Note that this sets up the trace fd as soon as we assign the variable, so it
748# must come after the creation of descriptor 4 above. Likewise, we must never
749# unset this, as it has the side effect of closing descriptor 4, which we
750# use to show verbose tests to the user.
751#
752# Note also that we don't need or want to export it. The tracing is local to
753# this shell, and we would not want to influence any shells we exec.
754BASH_XTRACEFD=4
755
e1970ce4
JH
756test_failure=0
757test_count=0
41ac414e
JH
758test_fixed=0
759test_broken=0
2d84e9fb 760test_success=0
e1970ce4 761
49da4040
FS
762test_missing_prereq=
763
d998bd4a
ÆAB
764test_external_has_tap=0
765
faa4bc35 766die () {
6e7b5aaf 767 code=$?
900721e1
JS
768 # This is responsible for running the atexit commands even when a
769 # test script run with '--immediate' fails, or when the user hits
770 # ctrl-C, i.e. when 'test_done' is not invoked at all.
771 test_atexit_handler || code=$?
6e7b5aaf
CB
772 if test -n "$GIT_EXIT_OK"
773 then
774 exit $code
775 else
776 echo >&5 "FATAL: Unexpected exit with code $code"
777 exit 1
778 fi
faa4bc35
CB
779}
780
6e7b5aaf 781GIT_EXIT_OK=
35641310 782trap 'die' EXIT
c5c39f4e
SG
783# Disable '-x' tracing, because with some shells, notably dash, it
784# prevents running the cleanup commands when a test script run with
785# '--verbose-log -x' is interrupted.
786trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
41184273 787
12a29b1a
TR
788# The user-facing functions are loaded from a separate file so that
789# test_perf subshells can have them too
3c8f12c9 790. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 791
886856ab 792# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 793# the test_expect_* functions instead.
886856ab
JH
794
795test_ok_ () {
d5d9de1b 796 test_success=$(($test_success + 1))
633fe50a 797 say_color "" "ok $test_count - $@"
3069f2a6 798 finalize_test_case_output ok "$@"
e1970ce4
JH
799}
800
886856ab 801test_failure_ () {
3069f2a6 802 failure_label=$1
d5d9de1b 803 test_failure=$(($test_failure + 1))
e31600b0 804 say_color error "not ok $test_count - $1"
bf0dd8a8 805 shift
cb1aefda 806 printf '%s\n' "$*" | sed -e 's/^/# /'
bbfbcd25
ÆAB
807 if test -n "$immediate"
808 then
809 say_color error "1..$test_count"
810 _error_exit
811 fi
3069f2a6 812 finalize_test_case_output failure "$failure_label" "$@"
886856ab
JH
813}
814
41ac414e 815test_known_broken_ok_ () {
41ac414e 816 test_fixed=$(($test_fixed+1))
633fe50a 817 say_color error "ok $test_count - $@ # TODO known breakage vanished"
3069f2a6 818 finalize_test_case_output fixed "$@"
41ac414e
JH
819}
820
821test_known_broken_failure_ () {
41ac414e 822 test_broken=$(($test_broken+1))
633fe50a 823 say_color warn "not ok $test_count - $@ # TODO known breakage"
3069f2a6 824 finalize_test_case_output broken "$@"
41ac414e 825}
886856ab
JH
826
827test_debug () {
8e832ebc 828 test "$debug" = "" || eval "$1"
e1970ce4
JH
829}
830
e6a6ddc9
TR
831match_pattern_list () {
832 arg="$1"
833 shift
834 test -z "$*" && return 1
560bf518
JK
835 # We need to use "$*" to get field-splitting, but we want to
836 # disable globbing, since we are matching against an arbitrary
837 # $arg, not what's in the filesystem. Using "set -f" accomplishes
838 # that, but we must do it in a subshell to avoid impacting the
839 # rest of the script. The exit value of the subshell becomes
840 # the function's return value.
841 (
842 set -f
843 for pattern_ in $*
844 do
845 case "$arg" in
846 $pattern_)
847 exit 0
848 ;;
849 esac
850 done
851 exit 1
852 )
e6a6ddc9
TR
853}
854
0445e6f0 855match_test_selector_list () {
f21ac368
EN
856 operation="$1"
857 shift
0445e6f0
IB
858 title="$1"
859 shift
860 arg="$1"
861 shift
862 test -z "$1" && return 0
863
f21ac368 864 # Commas are accepted as separators.
0445e6f0 865 OLDIFS=$IFS
f21ac368 866 IFS=','
0445e6f0
IB
867 set -- $1
868 IFS=$OLDIFS
869
870 # If the first selector is negative we include by default.
871 include=
872 case "$1" in
873 !*) include=t ;;
874 esac
875
876 for selector
877 do
878 orig_selector=$selector
879
880 positive=t
881 case "$selector" in
882 !*)
883 positive=
884 selector=${selector##?}
885 ;;
886 esac
887
888 test -z "$selector" && continue
889
890 case "$selector" in
891 *-*)
892 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
893 then
f21ac368 894 echo "error: $operation: invalid non-numeric in range" \
0445e6f0
IB
895 "start: '$orig_selector'" >&2
896 exit 1
897 fi
898 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
899 then
f21ac368 900 echo "error: $operation: invalid non-numeric in range" \
0445e6f0
IB
901 "end: '$orig_selector'" >&2
902 exit 1
903 fi
904 ;;
905 *)
906 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
907 then
f21ac368
EN
908 case "$title" in *${selector}*)
909 include=$positive
910 ;;
911 esac
912 continue
0445e6f0
IB
913 fi
914 esac
915
916 # Short cut for "obvious" cases
917 test -z "$include" && test -z "$positive" && continue
918 test -n "$include" && test -n "$positive" && continue
919
920 case "$selector" in
921 -*)
922 if test $arg -le ${selector#-}
923 then
924 include=$positive
925 fi
926 ;;
927 *-)
928 if test $arg -ge ${selector%-}
929 then
930 include=$positive
931 fi
932 ;;
933 *-*)
934 if test ${selector%%-*} -le $arg \
935 && test $arg -le ${selector#*-}
936 then
937 include=$positive
938 fi
939 ;;
940 *)
941 if test $arg -eq $selector
942 then
943 include=$positive
944 fi
945 ;;
946 esac
947 done
948
949 test -n "$include"
950}
951
ff09af3f
TR
952maybe_teardown_verbose () {
953 test -z "$verbose_only" && return
954 exec 4>/dev/null 3>/dev/null
955 verbose=
956}
957
958last_verbose=t
959maybe_setup_verbose () {
960 test -z "$verbose_only" && return
560bf518 961 if match_pattern_list $test_count "$verbose_only"
ff09af3f
TR
962 then
963 exec 4>&2 3>&1
964 # Emit a delimiting blank line when going from
965 # non-verbose to verbose. Within verbose mode the
966 # delimiter is printed by test_expect_*. The choice
967 # of the initial $last_verbose is such that before
968 # test 1, we do not print it.
969 test -z "$last_verbose" && echo >&3 ""
970 verbose=t
971 else
972 exec 4>/dev/null 3>/dev/null
973 verbose=
974 fi
975 last_verbose=$verbose
976}
977
5dfc368f
TR
978maybe_teardown_valgrind () {
979 test -z "$GIT_VALGRIND" && return
980 GIT_VALGRIND_ENABLED=
981}
982
983maybe_setup_valgrind () {
984 test -z "$GIT_VALGRIND" && return
26a07309 985 if test -z "$valgrind_only"
5dfc368f
TR
986 then
987 GIT_VALGRIND_ENABLED=t
988 return
989 fi
990 GIT_VALGRIND_ENABLED=
560bf518 991 if match_pattern_list $test_count "$valgrind_only"
5dfc368f
TR
992 then
993 GIT_VALGRIND_ENABLED=t
994 fi
995}
996
477dcadd 997trace_level_=0
9b5fe78b 998want_trace () {
f5ba2de6
JK
999 test "$trace" = t && {
1000 test "$verbose" = t || test "$verbose_log" = t
1001 }
9b5fe78b
JK
1002}
1003
a136f6d8
JK
1004# This is a separate function because some tests use
1005# "return" to end a test_expect_success block early
1006# (and we want to make sure we run any cleanup like
1007# "set +x").
1008test_eval_inner_ () {
1009 # Do not add anything extra (including LF) after '$*'
1010 eval "
477dcadd 1011 want_trace && trace_level_=$(($trace_level_+1)) && set -x
a136f6d8
JK
1012 $*"
1013}
1014
a7c58f28 1015test_eval_ () {
90c8a1db
JK
1016 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1017 # with non-test commands. But once in "set -x" mode, we cannot prevent
a136f6d8
JK
1018 # the shell from printing the "set +x" to turn it off (nor the saving
1019 # of $? before that). But we can make sure that the output goes to
1020 # /dev/null.
1021 #
90c8a1db
JK
1022 # There are a few subtleties here:
1023 #
1024 # - we have to redirect descriptor 4 in addition to 2, to cover
1025 # BASH_XTRACEFD
1026 #
1027 # - the actual eval has to come before the redirection block (since
1028 # it needs to see descriptor 4 to set up its stderr)
1029 #
1030 # - likewise, any error message we print must be outside the block to
1031 # access descriptor 4
1032 #
1033 # - checking $? has to come immediately after the eval, but it must
1034 # be _inside_ the block to avoid polluting the "set -x" output
1035 #
1036
1037 test_eval_inner_ "$@" </dev/null >&3 2>&4
a136f6d8 1038 {
a136f6d8 1039 test_eval_ret_=$?
9b5fe78b 1040 if want_trace
a136f6d8 1041 then
477dcadd
JS
1042 test 1 = $trace_level_ && set +x
1043 trace_level_=$(($trace_level_-1))
a136f6d8 1044 fi
90c8a1db
JK
1045 } 2>/dev/null 4>&2
1046
1047 if test "$test_eval_ret_" != 0 && want_trace
1048 then
1049 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
1050 fi
a136f6d8 1051 return $test_eval_ret_
a7c58f28
JN
1052}
1053
4d9d62fa 1054test_run_ () {
b6b0afdc 1055 test_cleanup=:
b586744a 1056 expecting_failure=$2
bb79af9d 1057
92b269f5 1058 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
1059 # turn off tracing for this test-eval, as it simply creates
1060 # confusing noise in the "-x" output
1061 trace_tmp=$trace
1062 trace=
bb79af9d
JK
1063 # 117 is magic because it is unlikely to match the exit
1064 # code of other programs
2d86a962
JK
1065 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)" ||
1066 {
1067 test "${GIT_TEST_CHAIN_LINT_HARDER:-${GIT_TEST_CHAIN_LINT_HARDER_DEFAULT:-1}}" != 0 &&
1068 $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!')
1069 }
99a64e4b 1070 then
165293af 1071 BUG "broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 1072 fi
2a01ef8c 1073 trace=$trace_tmp
bb79af9d
JK
1074 fi
1075
a57397b0 1076 setup_malloc_check
a7c58f28 1077 test_eval_ "$1"
b6b0afdc 1078 eval_ret=$?
a57397b0 1079 teardown_malloc_check
b586744a 1080
a136f6d8
JK
1081 if test -z "$immediate" || test $eval_ret = 0 ||
1082 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 1083 then
1b3185fc 1084 setup_malloc_check
a7c58f28 1085 test_eval_ "$test_cleanup"
1b3185fc 1086 teardown_malloc_check
b586744a 1087 fi
1c0cc756
RJ
1088 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1089 then
57e1538a
ÆAB
1090 echo ""
1091 fi
aa0bcf96 1092 return "$eval_ret"
4d9d62fa
PR
1093}
1094
ae75342c 1095test_start_ () {
8586f98b 1096 test_count=$(($test_count+1))
ff09af3f 1097 maybe_setup_verbose
5dfc368f 1098 maybe_setup_valgrind
0f5ae593 1099 start_test_case_output "$@"
ae75342c
TR
1100}
1101
1102test_finish_ () {
1103 echo >&3 ""
5dfc368f 1104 maybe_teardown_valgrind
ff09af3f 1105 maybe_teardown_verbose
af9912ef
JS
1106 if test -n "$GIT_TEST_TEE_OFFSET"
1107 then
1108 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1109 "$GIT_TEST_TEE_OUTPUT_FILE")
1110 fi
ae75342c
TR
1111}
1112
1113test_skip () {
04ece593 1114 to_skip=
ef2ac68d 1115 skipped_reason=
560bf518 1116 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
e6a6ddc9
TR
1117 then
1118 to_skip=t
ef2ac68d 1119 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 1120 fi
e0316695 1121 if test -z "$to_skip" && test -n "$run_list" &&
f21ac368 1122 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
e0316695
SG
1123 then
1124 to_skip=t
1125 skipped_reason="--run"
1126 fi
05236a5e
JN
1127 if test -z "$to_skip" && test -n "$test_prereq" &&
1128 ! test_have_prereq "$test_prereq"
a7bb3940
JS
1129 then
1130 to_skip=t
ef2ac68d 1131
07431fc8 1132 of_prereq=
05236a5e 1133 if test "$missing_prereq" != "$test_prereq"
07431fc8 1134 then
05236a5e 1135 of_prereq=" of $test_prereq"
07431fc8 1136 fi
ef2ac68d 1137 skipped_reason="missing $missing_prereq${of_prereq}"
49da4040
FS
1138
1139 # Keep a list of all the missing prereq for result aggregation
1140 if test -z "$missing_prereq"
1141 then
1142 test_missing_prereq=$missing_prereq
1143 else
1144 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1145 fi
ef2ac68d 1146 fi
07431fc8 1147
ef2ac68d
IB
1148 case "$to_skip" in
1149 t)
22231908 1150
ef2ac68d 1151 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593 1152 : true
3069f2a6 1153 finalize_test_case_output skip "$@"
04ece593
JH
1154 ;;
1155 *)
1156 false
1157 ;;
1158 esac
1159}
1160
342e9ef2
TR
1161# stub; perf-lib overrides it
1162test_at_end_hook_ () {
1163 :
1164}
1165
900721e1
JS
1166test_atexit_cleanup=:
1167test_atexit_handler () {
1168 # In a succeeding test script 'test_atexit_handler' is invoked
1169 # twice: first from 'test_done', then from 'die' in the trap on
1170 # EXIT.
1171 # This condition and resetting 'test_atexit_cleanup' below makes
1172 # sure that the registered cleanup commands are run only once.
1173 test : != "$test_atexit_cleanup" || return 0
1174
1175 setup_malloc_check
1176 test_eval_ "$test_atexit_cleanup"
1177 test_atexit_cleanup=:
1178 teardown_malloc_check
1179}
1180
e1970ce4 1181test_done () {
6e7b5aaf 1182 GIT_EXIT_OK=t
2d84e9fb 1183
900721e1
JS
1184 # Run the atexit commands _before_ the trash directory is
1185 # removed, so the commands can access pidfiles and socket files.
1186 test_atexit_handler
1187
78d5e4cf 1188 finalize_test_output
22231908 1189
1c0cc756
RJ
1190 if test -z "$HARNESS_ACTIVE"
1191 then
62c379b8 1192 mkdir -p "$TEST_RESULTS_DIR"
8ef1abe5 1193
62c379b8 1194 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
c54e6be7
ML
1195 total $test_count
1196 success $test_success
1197 fixed $test_fixed
1198 broken $test_broken
1199 failed $test_failure
49da4040 1200 missing_prereq $test_missing_prereq
c54e6be7
ML
1201
1202 EOF
8ef1abe5 1203 fi
41ac414e
JH
1204
1205 if test "$test_fixed" != 0
1206 then
633fe50a 1207 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
1208 fi
1209 if test "$test_broken" != 0
1210 then
633fe50a 1211 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
1212 fi
1213 if test "$test_broken" != 0 || test "$test_fixed" != 0
1214 then
1215 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1216 msg="remaining $test_remaining test(s)"
11d54b8b 1217 else
b73d9a23 1218 test_remaining=$test_count
11d54b8b 1219 msg="$test_count test(s)"
41ac414e 1220 fi
e1970ce4 1221 case "$test_failure" in
10b94e28 1222 0)
1c0cc756
RJ
1223 if test $test_external_has_tap -eq 0
1224 then
b73d9a23 1225 if test $test_remaining -gt 0
d87bd7c1 1226 then
633fe50a 1227 say_color pass "# passed all $msg"
d87bd7c1 1228 fi
c7018be5
JH
1229
1230 # Maybe print SKIP message
1231 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1232 case "$test_count" in
1233 0)
1234 say "1..$test_count${skip_all:+ $skip_all}"
1235 ;;
1236 *)
1237 test -z "$skip_all" ||
1238 say_color warn "$skip_all"
1239 say "1..$test_count"
1240 ;;
1241 esac
d998bd4a 1242 fi
abc5d372 1243
edc23840 1244 if test -z "$debug" && test -n "$remove_trash"
4d0912a2 1245 then
06478dab 1246 test -d "$TRASH_DIRECTORY" ||
4d0912a2 1247 error "Tests passed but trash directory already removed before test cleanup; aborting"
abc5d372 1248
06478dab 1249 cd "$TRASH_DIRECTORY/.." &&
046e90d1
JS
1250 rm -fr "$TRASH_DIRECTORY" || {
1251 # try again in a bit
1252 sleep 5;
1253 rm -fr "$TRASH_DIRECTORY"
1254 } ||
4d0912a2 1255 error "Tests passed but test cleanup failed; aborting"
4d0912a2 1256 fi
342e9ef2
TR
1257 test_at_end_hook_
1258
e1970ce4
JH
1259 exit 0 ;;
1260
1261 *)
1c0cc756
RJ
1262 if test $test_external_has_tap -eq 0
1263 then
633fe50a
TR
1264 say_color error "# failed $test_failure among $msg"
1265 say "1..$test_count"
d998bd4a 1266 fi
5099b99d 1267
e1970ce4
JH
1268 exit 1 ;;
1269
1270 esac
1271}
1272
e4597aae 1273if test -n "$valgrind"
4e1be63c 1274then
4e1be63c
JS
1275 make_symlink () {
1276 test -h "$2" &&
1277 test "$1" = "$(readlink "$2")" || {
1278 # be super paranoid
1279 if mkdir "$2".lock
1280 then
1281 rm -f "$2" &&
1282 ln -s "$1" "$2" &&
1283 rm -r "$2".lock
1284 else
1285 while test -d "$2".lock
1286 do
1287 say "Waiting for lock on $2."
1288 sleep 1
1289 done
1290 fi
1291 }
1292 }
1293
1294 make_valgrind_symlink () {
36bfb0e5 1295 # handle only executables, unless they are shell libraries that
11d62145 1296 # need to be in the exec-path.
36bfb0e5 1297 test -x "$1" ||
2a59a6ef 1298 test "# " = "$(test_copy_bytes 2 <"$1")" ||
36bfb0e5 1299 return;
4e1be63c
JS
1300
1301 base=$(basename "$1")
28fab7b2
RS
1302 case "$base" in
1303 test-*)
1304 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1305 ;;
1306 *)
1307 symlink_target="$GIT_BUILD_DIR/$base"
1308 ;;
1309 esac
4e1be63c
JS
1310 # do not override scripts
1311 if test -x "$symlink_target" &&
1312 test ! -d "$symlink_target" &&
2a59a6ef 1313 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
4e1be63c
JS
1314 then
1315 symlink_target=../valgrind.sh
1316 fi
efd92ffd
JS
1317 case "$base" in
1318 *.sh|*.perl)
1319 symlink_target=../unprocessed-script
1320 esac
4e1be63c
JS
1321 # create the link, or replace it if it is out of date
1322 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1323 }
1324
26a07309
TR
1325 # override all git executables in TEST_DIRECTORY/..
1326 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1327 mkdir -p "$GIT_VALGRIND"/bin
503e2241 1328 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
1329 do
1330 make_valgrind_symlink $file
1331 done
1332 # special-case the mergetools loadables
1333 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1334 OLDIFS=$IFS
1335 IFS=:
1336 for path in $PATH
1337 do
1338 ls "$path"/git-* 2> /dev/null |
1339 while read file
ad0e6233 1340 do
26a07309 1341 make_valgrind_symlink "$file"
ad0e6233 1342 done
26a07309
TR
1343 done
1344 IFS=$OLDIFS
4e1be63c
JS
1345 PATH=$GIT_VALGRIND/bin:$PATH
1346 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1347 export GIT_VALGRIND
952af351
TR
1348 GIT_VALGRIND_MODE="$valgrind"
1349 export GIT_VALGRIND_MODE
5dfc368f 1350 GIT_VALGRIND_ENABLED=t
26a07309 1351 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 1352 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
1353elif test -n "$GIT_TEST_INSTALLED"
1354then
e4597aae
MO
1355 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1356 error "Cannot run git from $GIT_TEST_INSTALLED."
16df35cb 1357 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
e4597aae
MO
1358 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1359else # normal case, use ../bin-wrappers only unless $with_dashes:
dd167a30 1360 if test -n "$no_bin_wrappers"
1c0cc756 1361 then
dd167a30
JS
1362 with_dashes=t
1363 else
1364 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1365 if ! test -x "$git_bin_dir/git"
1c0cc756 1366 then
dd167a30
JS
1367 if test -z "$with_dashes"
1368 then
1369 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1370 fi
1371 with_dashes=t
e4597aae 1372 fi
dd167a30 1373 PATH="$git_bin_dir:$PATH"
e4597aae 1374 fi
6cec5c68 1375 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
1376 if test -n "$with_dashes"
1377 then
ca7312d3 1378 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
e4597aae 1379 fi
4e1be63c 1380fi
6cec5c68 1381GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 1382GIT_CONFIG_NOSYSTEM=1
3c995beb 1383GIT_ATTR_NOSYSTEM=1
614c3d8f
SG
1384GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1385export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
49ccb087 1386
5e87eae9
JH
1387if test -z "$GIT_TEST_CMP"
1388then
1389 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1390 then
1391 GIT_TEST_CMP="$DIFF -c"
1392 else
1393 GIT_TEST_CMP="$DIFF -u"
1394 fi
1395fi
1396
20d2a30f 1397GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
6fcca938 1398export GITPERLLIB
6cec5c68 1399test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
1400 error "You haven't built things yet, have you?"
1401}
e1970ce4 1402
d609615f 1403if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1c0cc756 1404then
0e496492
NTND
1405 echo >&2 'You need to build test-tool:'
1406 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
56cf9806
EW
1407 exit 1
1408fi
1409
edc23840
ÆAB
1410# Are we running this test at all?
1411remove_trash=
1412this_test=${0##*/}
1413this_test=${this_test%%-*}
560bf518 1414if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
edc23840
ÆAB
1415then
1416 say_color info >&3 "skipping test $this_test altogether"
1417 skip_all="skip all tests in $this_test"
1418 test_done
1419fi
1420
956d2e46
ÆAB
1421# skip non-whitelisted tests when compiled with SANITIZE=leak
1422if test -n "$SANITIZE_LEAK"
1423then
1424 if test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1425 then
1426 # We need to see it in "git env--helper" (via
1427 # test_bool_env)
1428 export TEST_PASSES_SANITIZE_LEAK
1429
1430 if ! test_bool_env TEST_PASSES_SANITIZE_LEAK false
1431 then
1432 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1433 test_done
1434 fi
1435 fi
1436elif test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1437then
234383cd 1438 BAIL_OUT "GIT_TEST_PASSING_SANITIZE_LEAK=true has no effect except when compiled with SANITIZE=leak"
956d2e46
ÆAB
1439fi
1440
edc23840 1441# Last-minute variable setup
add5240f 1442USER_HOME="$HOME"
edc23840
ÆAB
1443HOME="$TRASH_DIRECTORY"
1444GNUPGHOME="$HOME/gnupg-home-not-used"
add5240f 1445export HOME GNUPGHOME USER_HOME
edc23840 1446
5d22e189
ÆAB
1447# "rm -rf" existing trash directory, even if a previous run left it
1448# with bad permissions.
1449remove_trash_directory () {
1450 dir="$1"
1451 if ! rm -rf "$dir" 2>/dev/null
1452 then
1453 chmod -R u+rwx "$dir"
1454 rm -rf "$dir"
1455 fi
1456 ! test -d "$dir"
1457}
1458
e1970ce4 1459# Test repository
5d22e189 1460remove_trash_directory "$TRASH_DIRECTORY" || {
6e7b5aaf 1461 GIT_EXIT_OK=t
8d14ac94
JH
1462 echo >&5 "FATAL: Cannot prepare test area"
1463 exit 1
1464}
1465
edc23840 1466remove_trash=t
1c0cc756
RJ
1467if test -z "$TEST_NO_CREATE_REPO"
1468then
f0d4d398
ÆAB
1469 git init "$TRASH_DIRECTORY" >&3 2>&4 ||
1470 error "cannot run git init"
342e9ef2 1471else
38b074de 1472 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 1473fi
22231908 1474
1bd9c648
LW
1475# Use -P to resolve symlinks in our working directory so that the cwd
1476# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 1477cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 1478
78d5e4cf 1479start_test_output "$0"
22231908 1480
192b5175 1481# Convenience
70507911 1482# A regexp to match 5 and 35 hexdigits
192b5175 1483_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1484_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
192b5175 1485
1486test_oid_init
1487
1488ZERO_OID=$(test_oid zero)
1489OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
a1142963 1490OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
192b5175 1491EMPTY_TREE=$(test_oid empty_tree)
1492EMPTY_BLOB=$(test_oid empty_blob)
192b5175 1493
11f470ae
JH
1494# Provide an implementation of the 'yes' utility; the upper bound
1495# limit is there to help Windows that cannot stop this loop from
1496# wasting cycles when the downstream stops reading, so do not be
1497# tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1498# limit the output of the yes utility", 2016-02-02)
8648732e
BC
1499yes () {
1500 if test $# = 0
1501 then
1502 y=y
1503 else
1504 y="$*"
1505 fi
1506
6129c930
JS
1507 i=0
1508 while test $i -lt 99
8648732e 1509 do
6129c930
JS
1510 echo "$y"
1511 i=$(($i+1))
8648732e
BC
1512 done
1513}
1514
c7400399
ÆAB
1515# The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1516# thus needs to be set up really early, and set an internal variable
1517# for convenience so the hot test_set_prereq() codepath doesn't need
43a2afee
SG
1518# to call "git env--helper" (via test_bool_env). Only do that work
1519# if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
c7400399
ÆAB
1520GIT_TEST_FAIL_PREREQS_INTERNAL=
1521if test -n "$GIT_TEST_FAIL_PREREQS"
1522then
43a2afee 1523 if test_bool_env GIT_TEST_FAIL_PREREQS false
c7400399
ÆAB
1524 then
1525 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1526 test_set_prereq FAIL_PREREQS
1527 fi
1528else
1529 test_lazy_prereq FAIL_PREREQS '
43a2afee 1530 test_bool_env GIT_TEST_FAIL_PREREQS false
c7400399
ÆAB
1531 '
1532fi
1533
7187c7bb 1534# Fix some commands on Windows, and other OS-specific things
d98b2c5f
JS
1535uname_s=$(uname -s)
1536case $uname_s in
f17e9fbb
JS
1537*MINGW*)
1538 # Windows has its own (incompatible) sort and find
1539 sort () {
1540 /usr/bin/sort "$@"
1541 }
1542 find () {
1543 /usr/bin/find "$@"
1544 }
4114156a
JS
1545 # git sees Windows-style pwd
1546 pwd () {
1547 builtin pwd -W
1548 }
ee9fb68c 1549 # no POSIX permissions
6fd1106a 1550 # backslashes in pathspec are converted to '/'
fb9a2bea 1551 # exec does not inherit the PID
a94114ad 1552 test_set_prereq MINGW
5f4e02e5 1553 test_set_prereq NATIVE_CRLF
a31d0665 1554 test_set_prereq SED_STRIPS_CR
97669eed 1555 test_set_prereq GREP_STRIPS_CR
bccc37fd 1556 test_set_prereq WINDOWS
4d715ac0 1557 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1558 ;;
1559*CYGWIN*)
1560 test_set_prereq POSIXPERM
a31d0665 1561 test_set_prereq EXECKEEPSPID
cfa96496 1562 test_set_prereq CYGWIN
a31d0665 1563 test_set_prereq SED_STRIPS_CR
97669eed 1564 test_set_prereq GREP_STRIPS_CR
bccc37fd 1565 test_set_prereq WINDOWS
ee9fb68c
JS
1566 ;;
1567*)
1568 test_set_prereq POSIXPERM
6fd1106a 1569 test_set_prereq BSLASHPSPEC
fb9a2bea 1570 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1571 ;;
1572esac
704a3143 1573
ddcfc7c6
GP
1574# Detect arches where a few things don't work
1575uname_m=$(uname -m)
1576case $uname_m in
1577parisc* | hppa*)
1578 test_set_prereq HPPA
1579 ;;
1580esac
1581
c305e667
HWN
1582test_set_prereq REFFILES
1583
b082687c 1584( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
7596fe95 1585test -z "$NO_CURL" && test_set_prereq LIBCURL
1b19ccd2 1586test -z "$NO_PERL" && test_set_prereq PERL
68c7d276 1587test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
d4e1b47a 1588test -z "$NO_PYTHON" && test_set_prereq PYTHON
7599730b 1589test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
ce9a2570 1590test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
5e9637c6 1591test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
2cdc292b 1592test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
58407e04 1593test -n "$GIT_VALGRIND_ENABLED" && test_set_prereq VALGRIND
1b19ccd2 1594
4592e608
NTND
1595if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1596then
1597 GIT_TEST_CHECK_CACHE_TREE=true
1598 export GIT_TEST_CHECK_CACHE_TREE
1599fi
1600
20073274
AS
1601test_lazy_prereq PIPE '
1602 # test whether the filesystem supports FIFOs
7b7bea23
RJ
1603 test_have_prereq !MINGW,!CYGWIN &&
1604 rm -f testfifo && mkfifo testfifo
20073274
AS
1605'
1606
04083f27
JH
1607test_lazy_prereq SYMLINKS '
1608 # test whether the filesystem supports symbolic links
1609 ln -s x y && test -h y
1610'
c91cfd19 1611
3e7d4888
TB
1612test_lazy_prereq SYMLINKS_WINDOWS '
1613 # test whether symbolic links are enabled on Windows
1614 test_have_prereq MINGW &&
1615 cmd //c "mklink y x" &> /dev/null && test -h y
1616'
1617
b018c735
JN
1618test_lazy_prereq FILEMODE '
1619 test "$(git config --bool core.filemode)" = true
1620'
1621
ac39aa61
MG
1622test_lazy_prereq CASE_INSENSITIVE_FS '
1623 echo good >CamelCase &&
1624 echo bad >camelcase &&
1625 test "$(cat CamelCase)" != good
1626'
1627
6ec63305
WC
1628test_lazy_prereq FUNNYNAMES '
1629 test_have_prereq !MINGW &&
1630 touch -- \
1631 "FUNNYNAMES tab embedded" \
1632 "FUNNYNAMES \"quote embedded\"" \
1633 "FUNNYNAMES newline
1634embedded" 2>/dev/null &&
1635 rm -- \
1636 "FUNNYNAMES tab embedded" \
1637 "FUNNYNAMES \"quote embedded\"" \
1638 "FUNNYNAMES newline
1639embedded" 2>/dev/null
1640'
1641
5b0b5dd4
MG
1642test_lazy_prereq UTF8_NFD_TO_NFC '
1643 # check whether FS converts nfd unicode to nfc
1644 auml=$(printf "\303\244")
1645 aumlcdiar=$(printf "\141\314\210")
1646 >"$auml" &&
742ae10e 1647 test -f "$aumlcdiar"
5b0b5dd4
MG
1648'
1649
09feffb6
JK
1650test_lazy_prereq AUTOIDENT '
1651 sane_unset GIT_AUTHOR_NAME &&
1652 sane_unset GIT_AUTHOR_EMAIL &&
1653 git var GIT_AUTHOR_IDENT
1654'
1655
6219bb22
JH
1656test_lazy_prereq EXPENSIVE '
1657 test -n "$GIT_TEST_LONG"
1658'
1659
5b1fe6eb
ÆAB
1660test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1661 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1662'
1663
e1ecd9e3
JH
1664test_lazy_prereq USR_BIN_TIME '
1665 test -x /usr/bin/time
1666'
1667
1767c517
JK
1668test_lazy_prereq NOT_ROOT '
1669 uid=$(id -u) &&
1670 test "$uid" != 0
1671'
1672
63b747ce 1673test_lazy_prereq JGIT '
abd0f289 1674 jgit --version
63b747ce
JT
1675'
1676
719c3da2
JH
1677# SANITY is about "can you correctly predict what the filesystem would
1678# do by only looking at the permission bits of the files and
1679# directories?" A typical example of !SANITY is running the test
1680# suite as root, where a test may expect "chmod -r file && cat file"
1681# to fail because file is supposed to be unreadable after a successful
1682# chmod. In an environment (i.e. combination of what filesystem is
1683# being used and who is running the tests) that lacks SANITY, you may
1684# be able to delete or create a file when the containing directory
1685# doesn't have write permissions, or access a file even if the
1686# containing directory doesn't have read or execute permissions.
1687
f400e51c
TB
1688test_lazy_prereq SANITY '
1689 mkdir SANETESTD.1 SANETESTD.2 &&
1690
1691 chmod +w SANETESTD.1 SANETESTD.2 &&
1692 >SANETESTD.1/x 2>SANETESTD.2/x &&
1693 chmod -w SANETESTD.1 &&
719c3da2 1694 chmod -r SANETESTD.1/x &&
f400e51c 1695 chmod -rx SANETESTD.2 ||
165293af 1696 BUG "cannot prepare SANETESTD"
f400e51c 1697
719c3da2 1698 ! test -r SANETESTD.1/x &&
f400e51c
TB
1699 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1700 status=$?
1701
1702 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1703 rm -rf SANETESTD.1 SANETESTD.2 ||
165293af 1704 BUG "cannot clean SANETESTD"
f400e51c
TB
1705 return $status
1706'
f838ce58 1707
d98b2c5f 1708test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1709GIT_UNZIP=${GIT_UNZIP:-unzip}
1710test_lazy_prereq UNZIP '
1711 "$GIT_UNZIP" -v
1712 test $? -ne 127
1713'
9a308de3
JK
1714
1715run_with_limited_cmdline () {
1716 (ulimit -s 128 && "$@")
1717}
1718
21dac1de 1719test_lazy_prereq CMDLINE_LIMIT '
ddcfc7c6 1720 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
21dac1de
RJ
1721 run_with_limited_cmdline true
1722'
6b9c38e1 1723
4db464f8
MG
1724run_with_limited_stack () {
1725 (ulimit -s 128 && "$@")
1726}
1727
21dac1de 1728test_lazy_prereq ULIMIT_STACK_SIZE '
ddcfc7c6 1729 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
21dac1de
RJ
1730 run_with_limited_stack true
1731'
4db464f8 1732
b30fdb4b
TB
1733run_with_limited_open_files () {
1734 (ulimit -n 32 && "$@")
1735}
1736
1737test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1738 test_have_prereq !MINGW,!CYGWIN &&
1739 run_with_limited_open_files true
1740'
1741
6b9c38e1
JK
1742build_option () {
1743 git version --build-options |
1744 sed -ne "s/^$1: //p"
1745}
1746
970fa57f
CMAB
1747test_lazy_prereq SIZE_T_IS_64BIT '
1748 test 8 -eq "$(build_option sizeof-size_t)"
1749'
1750
6b9c38e1
JK
1751test_lazy_prereq LONG_IS_64BIT '
1752 test 8 -le "$(build_option sizeof-long)"
1753'
a07fb050 1754
a801a7cf
NTND
1755test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1756test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
e9184b07
JK
1757
1758test_lazy_prereq CURL '
1759 curl --version
1760'
d16ab634 1761
1762# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1763# which will not work with other hash algorithms and tests that work but don't
1764# test anything meaningful (e.g. special values which cause short collisions).
1765test_lazy_prereq SHA1 '
c49fe07c 1766 case "$GIT_DEFAULT_HASH" in
1767 sha1) true ;;
1768 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1769 *) false ;;
1770 esac
d16ab634 1771'
11aad464 1772
7ccbea56
ÆAB
1773test_lazy_prereq ADD_I_USE_BUILTIN '
1774 test_bool_env GIT_TEST_ADD_I_USE_BUILTIN true
1775'
1776
2fec604f 1777# Ensure that no test accidentally triggers a Git command
31345d55
DS
1778# that runs the actual maintenance scheduler, affecting a user's
1779# system permanently.
1780# Tests that verify the scheduler integration must set this locally
2fec604f 1781# to avoid errors.
31345d55 1782GIT_TEST_MAINT_SCHEDULER="none:exit 1"
dd77cf61
JH
1783
1784# Does this platform support `git fsmonitor--daemon`
1785#
1786test_lazy_prereq FSMONITOR_DAEMON '
1787 git version --build-options >output &&
1788 grep "feature: fsmonitor--daemon" output
1789'